#!/bin/bash

BALENA_ENGINE=/usr/local/bin/balena-engine

[ -x "$BALENA_ENGINE" ] || exit 0

current_olip_api_pid=$( $BALENA_ENGINE inspect --format='{% raw %}{{index .State.Pid}}{% endraw %}' api 2>/dev/null )

[ -n current_olip_api_pid ] || {
  echo >&2 "Error: api container not found."
  exit 1
}

cdn_ideascube=$( avahi-resolve-host-name {{local_cache_server}} 2> /dev/null | awk -F " " '{print $2}' )

if expr "$cdn_ideascube" : '[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*$' >/dev/null;
then
  echo "CDN server found, updating /etc/hosts in API container."
  # shellcheck disable=SC2086
  $BALENA_ENGINE exec api sh -c 'LANG=C.UTF-8 grep -q '$cdn_ideascube' /etc/hosts || echo '$cdn_ideascube' s3.eu-central-1.wasabisys.com >> /etc/hosts'
  $BALENA_ENGINE inspect --format='{% raw %}{{index .State.Pid}}{% endraw %}' api > /var/run/olip-api.pid
else
  last_olip_api_pid=$( cat /var/run/olip-api.pid 2> /dev/null || echo 0 )

  if [ "$last_olip_api_pid" -eq "$current_olip_api_pid" ] ; then
    echo "The CDN server is gone, restarting the API container."
    $BALENA_ENGINE restart api
  else
    echo "No CDN server found."
  fi
fi
